#include "main.h"

//funtion prototypes
void show_counters(uint64_t counter_licht, uint64_t counter_move);

//variables
uint16_t licht_all_count = 0;
uint16_t move_all_count = 0;

void setup() {
  Serial.begin(115200);
  rgb_leds.begin();
  NVS.begin();
  moni.init();
  //load counters
  //NVS.setInt("licht", 100);
  //NVS.setInt("move", 50);
  licht_all_count = NVS.getInt("licht");
  move_all_count = NVS.getInt("move");
  // all relais off;
  relais_haeuser.off();
  relais_sterne.off();
  relais_spiegel.off();
  relais_other.off();

  zugoben.stop();
  zugunten.stop();
  
  led_tanne.setColor(rgb_leds.Color(0, 150, 0));
  rgbled_state_flag = rgbled_state_flag | LSTERNE;
  mp3ply.begin();
  mp3ply.stop();
}

uint8_t licht_count = 0;
bool faded_on = false;

void loop() {
  if(faded_on == false)
  {
    if(true == led_sterne.fade_on())
      faded_on = true;
  }
  else
  {
    if(true == led_sterne.fade_off()) 
      faded_on = false;
  }
  led_teich.rainbowCycle();
  rgb_leds.show();

  if(taster_aussen_licht.pressed())
  {
    relais_haeuser.toggle();
    licht_all_count++;
    NVS.setInt("licht", licht_all_count);
  }

  if(taster_aussen_move.pressed())
  {
    relais_other.toggle();
    move_all_count++;
    NVS.setInt("move", move_all_count);
  }

  if(taster_train_oben.pressed())
    relais_sterne.toggle();

  if(taster_train_unten.pressed())
    relais_spiegel.toggle();


  show_counters(licht_all_count, move_all_count);
  /*
  switch (licht_count)
  {
  case 1:
    haeuser.on();
    sterne.off();
    spiegel.off();
    other.off();
    break;
  case 2:
    haeuser.off();
    sterne.on();
    spiegel.off();
    other.off();
    break;
  case 3:
    haeuser.off();
    sterne.off();
    spiegel.on();
    other.off();
    break;   
  case 4:
    haeuser.off();
    sterne.off();
    spiegel.off();
    other.on();
    break;      
  default:
    haeuser.off();
    sterne.off();
    spiegel.off();
    other.off();  
    break;
  }
*/


}


void show_counters(uint64_t counter_licht, uint64_t counter_move)
{
  moni.clear();
  moni.header("Zaehler");
  moni.data(30,20,counter_licht, "Licht");
  moni.data(100,20,counter_move, "Moves");
  moni.show();
}
